namespace PolClient
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using PageBoxGrid;

	/// <p>User control controlling the transaction</p>
	/// <p>Copyright (c) 2002 Alexis Grandemange<br/>
	/// Mail: alexis.grandemange@pagebox.net</p>
	/// <pre>This program is free software; you can redistribute it and/or
	/// modify it under the terms of the GNU Lesser General Public
	/// License as published by the Free Software Foundation; version
	/// 2.1 of the License.
	/// This library is distributed in the hope that it will be useful,
	/// but WITHOUT ANY WARRANTY; without even the implied warranty of
	/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	/// GNU Lesser General Public License for more details.
	/// A copy of the GNU Lesser General Public License lesser.txt should be
	/// included in the distribution.</pre>
	public abstract class PolCommit : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Button ButCommit;
		protected System.Web.UI.WebControls.Panel CommitPanel;
		protected System.Web.UI.WebControls.Label labStatus;


		/// <summary>
		/// CSS class to use for the status
		/// </summary>
		private string statusCss = null;
		protected System.Web.UI.WebControls.Button ButRollback;
	
		public string StatusCss 
		{
			get { return statusCss; }
			set { statusCss = value; }
		}
		/// <summary>
		/// CSS class to use for the embedding panel
		/// </summary>
		private string css = null;
		public string Css 
		{
			get { return css; }
			set { css = value; }
		}

		/// <summary>
		public PolCommit()
		{
			this.Init += new System.EventHandler(Page_Init);
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack) 
			{
				if (css != null) 
					CommitPanel.CssClass = css;
				if (statusCss != null)
					labStatus.CssClass = statusCss;
			}
			string msg = (string)PageBoxGrid.Heap.Get(ID, Session.SessionID);
			if (msg != null) {
				PageBoxGrid.Heap.Remove(ID, Session.SessionID);
				labStatus.Text = msg;
			}
		}

		private void Page_Init(object sender, EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
		}

		#region Web Form Designer generated code
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ButCommit.Click += new System.EventHandler(this.OnCommit);
			this.ButRollback.Click += new System.EventHandler(this.OnRollback);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/// <summary>
		/// Called when the user clicks on the Commit button.
		/// Calls TransactionCoordinator.Commit.
		/// </summary>
		private void OnCommit(object sender, System.EventArgs e)
		{
			Hashtable ht = new Hashtable();
			if (!PageBoxGrid.TransactionCoordinator.Commit(ID, Session.SessionID, null, ref ht, Request)) 
			{
				if (ht.Count > 0) 
				{
					IDictionaryEnumerator ide = ht.GetEnumerator();
					ide.MoveNext();
					if (ide.Value is Exception)
						labStatus.Text = "[" + (string)ide.Key + "] " + ((Exception)ide.Value).Message;
					else
					if (ide.Value is string)
						labStatus.Text = "[" + (string)ide.Key + "] " + (string)ide.Value;
				} else
					labStatus.Text = "Transaction failed";
			} else
				labStatus.Text = "Transaction committed";
			// I didn't find a safer solution to update the other forms of the page
			PageBoxGrid.Heap.Put(ID, Session.SessionID, labStatus.Text);
			Response.Redirect(Request.Url.AbsolutePath);
		}

		/// <summary>
		/// Called when the user clicks on the Rollback button.
		/// Calls TransactionCoordinator.Rollback.
		/// </summary>
		private void OnRollback(object sender, System.EventArgs e)
		{
			Hashtable ht = new Hashtable();
			if (!PageBoxGrid.TransactionCoordinator.Rollback(ID, Session.SessionID, null, ref ht, Request)) 
			{
				if (ht.Count > 0) 
				{
					IDictionaryEnumerator ide = ht.GetEnumerator();
					ide.MoveNext();
					if (ide.Value is Exception)
						labStatus.Text = "[" + (string)ide.Key + "] " + ((Exception)ide.Value).Message;
					else
						if (ide.Value is string)
						labStatus.Text = "[" + (string)ide.Key + "] " + (string)ide.Value;
				}
			} 
			else
				labStatus.Text = "Transaction rollbacked";
			// I didn't find a safer solution to update the other forms of the page
			PageBoxGrid.Heap.Put(ID, Session.SessionID, labStatus.Text);
			Response.Redirect(Request.Url.AbsolutePath);
		}
	}
}
