﻿namespace PolClient {
    using System.Diagnostics;
    using System.Xml.Serialization;
    using System;
    using System.Web.Services.Protocols;
    using System.Web.Services;
        
	 /// <summary>
	 /// <p>Polaris Web service invocation.<br/>
	 /// Generated with wsdl.exe (wsdl /n:PolClient http://localhost/polaris/PolServer/ShoppingOrder.asmx).
	 /// Only change: construction setting the URL.</p>
	 /// <p>Copyright (c) 2002 Alexis Grandemange<br/>
	 /// Mail: alexis.grandemange@pagebox.net</p>
	 /// <pre>This program is free software; you can redistribute it and/or
	 /// modify it under the terms of the GNU Lesser General Public
	 /// License as published by the Free Software Foundation; version
	 /// 2.1 of the License.
	 /// This library is distributed in the hope that it will be useful,
	 /// but WITHOUT ANY WARRANTY; without even the implied warranty of
	 /// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	 /// GNU Lesser General Public License for more details.
	 /// A copy of the GNU Lesser General Public License lesser.txt should be
	 /// included in the distribution.</pre>
	 [System.Web.Services.WebServiceBindingAttribute(Name="ShoppingOrderSoap", Namespace="Polaris")]
    public class ShoppingOrder : System.Web.Services.Protocols.SoapHttpClientProtocol {
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public ShoppingOrder(string url) {
            this.Url = url;
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("Polaris/CheckAccount", RequestNamespace="Polaris", ResponseNamespace="Polaris", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public bool CheckAccount(string accountID) {
            object[] results = this.Invoke("CheckAccount", new object[] {
                        accountID});
            return ((bool)(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public System.IAsyncResult BeginCheckAccount(string accountID, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("CheckAccount", new object[] {
                        accountID}, callback, asyncState);
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public bool EndCheckAccount(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((bool)(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("Polaris/Order", RequestNamespace="Polaris", ResponseNamespace="Polaris", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public bool Order(string accountID, [System.Xml.Serialization.XmlArrayItemAttribute("OrderRow", IsNullable=true)] OrderRow[] lines) {
            object[] results = this.Invoke("Order", new object[] {
                        accountID,
                        lines});
            return ((bool)(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public System.IAsyncResult BeginOrder(string accountID, OrderRow[] lines, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("Order", new object[] {
                        accountID,
                        lines}, callback, asyncState);
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public bool EndOrder(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((bool)(results[0]));
        }
    }
    
    public class OrderRow {
        
        public string article;
        
        public int price;
        
        public int qty;
    }
}
